const syncBuffer=[]
const syncMapping={}
var syncLevel=0
function eventSyncRequest(from,req_id, x, y, obj_id, obj_id2)
{
    if (req_id<0){return}
    if (req_id==0)
    {
        var [fname,argv]=JSON.parse(String.fromCharCode(...syncBuffer.splice(0)))
        syncLevel+=1
        try{syncMapping[fname](...argv)}
        catch{}
        syncLevel-=1
        return
    }
    syncBuffer[x/128]=req_id
}

/** func must have "name" attribute and warpped in all clients
 * @template T
 * @param {T} func 
 * @returns {T}
 */
function synchronize(func)
{
    syncMapping[func.name]=func
    function func2(...argv)
    {
        if (syncLevel>0)return func(...argv)//already synchronized
        var argx=JSON.stringify([func.name,argv])
        for (const i in argx)
        {syncRequest(argx.charCodeAt(i),i,0)}
        syncRequest(0,0,0)
    }
    return func2
}



function print(...k)
{
    console("print:",JSON.stringify(k))
}
